#	KlankKleuren (LUCL-submission 'Concours Wetenschap & Wereld') 
#
#	Notes: - 'noprogress' seems to delay execution of 'demo Undo'
#	       - Drawing or Painting over *Painted* area's is not visible (even using demoShow())
#
#	J J A Pacilly, 28-may-2010, initial version for Willemijn Heeren/LUCL-colloquium
#	J J A Pacilly, 11-jun-2010, included suggestions by Vincent van Heuven  
#	J J A Pacilly, 10-jan-2013, translated visible text to English for Meghan Clayards  
#
#	Distributed under the GNU General Public License

form KlankKleuren
  integer stackPointer 0
  endform

if stackPointer == undefined
  stackPointer = 0
  endif
  
call bootKlankKleuren
call initKlankKleuren
if stackPointer == 0
  call showHelp
else
  call initGraph
  endif

while demoWaitForInput()
  if demoClickedIn(xMin, xMax, yMin, yMax)
    pitchHz  = erbToHertz(demoX())
    loudness = demoY()
    call synSound pitchHz loudness
  elsif demoKeyPressed()
    key$ = demoKey$()
    if key$ = "?" or key$ = "h" or key$ = "H"
      call showHelp
    elsif key$ = "n" or  key$ = "N"
      call synSoundKey
    elsif key$ = " "
      if demoShiftKeyPressed()
        call anaSound 25
      else
        call anaSound 1
	endif
    elsif index_regex(key$, "\n")
      call calcDistance
    elsif key$ = "o" or key$ = "O"
      call undoDemo
    elsif key$ = "s" or key$ = "S"
      call showScore
    elsif key$ = "k" or key$ = "K"
      call setRange
      call initGraph
    elsif key$ = "c" or key$ = "C"
      if demoShiftKeyPressed()
        call initKlankKleuren
        endif
      call initGraph
    elsif key$ = "g" or key$ = "G"
      call switchSndMessage
    elsif key$ = "1"
      symSize   = 1
      lineWidth = 1
    elsif key$ = "2"
      symSize   = 2
      lineWidth = 2
    elsif key$ = "3"
      symSize   = 3
      lineWidth = 3
    elsif key$ = "4"
      symSize   = 4
      lineWidth = 5
    elsif  key$ = ""
      call KlinkerMikken stackPointer+1
    elsif key$ = ""
      goto EXIT
    else
      call default
      endif
    endif
  endwhile


procedure bootKlankKleuren
  if stackPointer == 0
    demoWindowTitle("KlankKleuren - Phonetics Laboratory Leiden")
  else
    demoWindowTitle("KlankKleuren - Phonetics Laboratory Leiden ['stackPointer']")
    endif
  select all
  nocheck Remove
  xMin       =  2
  xMax       =  7
  yMin       = 60
  yMax       = 80
  xPitch     = (xMin + xMax) / 2
  yInt       =  0
  synF2_a    = 10
  synF1_a    =  8
  synF2_u    =  6
  synF1_u    =  3
  synF2_i    = 14
  synF1_i    =  2.7
  synF2_e    = (synF2_a + synF2_i)/2 + 1
  synF1_e    = (synF1_a + synF1_i)/2 + 1
  rndChoice  =  0
  debug      =  0
  sndMessage =  0
  call switchSndMessage
  osIsWindows = index(environment$("os"), "Windows")
  stopwatch
  endproc

procedure initKlankKleuren
  xMin            =  2
  xMax            =  7
  symSize         =  2
  lineWidth       =  2
  endproc

procedure resetKlankKleuren
  usrCounter      =  0
  usrEval         =  0
  usrHit          =  0
  missedBy        = 10
  undoCount       =  0
  eraseableObject =  0
  endproc

procedure showHelp
  call resetKlankKleuren
  demo Erase all
  demo 24
  demo Axes... -14 -6 -8 -2

  demo White
  demo Paint rectangle... Grey  -17 -3 -11 1
  demo Paint rectangle... {0.125,0.698,0.667} -14 -6 -8 -2
  demo Text special... -13.5 left -2.5 top Helvetica 18 0 ##Control Keys %%KlankKleuren%#'newline$'
... 'newline$'#H or #?
... 'newline$'mouse click
... 'newline$'<space>
... 'newline$'shift/<space>
... 'newline$'<Enter>
... 'newline$'#O
... 'newline$'#S
... 'newline$'#K or shift/#K
... 'newline$'#1, #2, #3 or #4
... 'newline$'#C
... 'newline$'shift/#C
... 'newline$'ctrl/#C
... 'newline$'ctrl/#X
  demo Text special... -11.5 left -2.5 top Helvetica 18 0 'newline$'
... 'newline$'show this help text
... 'newline$'synthesize example Sound (schwa)
... 'newline$'plot your Sound (sing before the beep)
... 'newline$'plot your Sound (sampling for about 15s)
... 'newline$'preserve colour if the target has been hit
... 'newline$'undo
... 'newline$'show your score
... 'newline$'define your vocal range
... 'newline$'select pencil size
... 'newline$'clear screen
... 'newline$'restart %%KlankKleuren%
... 'newline$'close the programm
... 'newline$'continue with %%KlinkerMikken%
  demo 14
  demo Viewport text... Centre Bottom 0 (press #C or shift/#C to restart %%KlankKleuren%)
  endproc

procedure initGraph
  call resetKlankKleuren
  demo Erase all
  demo 24
  demo Axes... xMin xMax yMin yMax

  demo Paint rectangle... {0.6,0.6,0.6} xMin-1 xMin yMin yMax+10
  demo Paint rectangle... {0.6,0.6,0.6} xMin xMax+1 yMax yMax+10
  demo Paint rectangle... {0.6,0.6,0.6} xMax xMax+1 yMin-10 yMax
  demo Paint rectangle... {0.6,0.6,0.6} xMin-1 xMax yMin-10 yMin
  demo Line width... 1
  demo Draw inner box

  demo Line width... lineWidth
  demo Black
  demo Draw circle... xMin+2.0 75 0.2
  demo Draw circle... xMin+3.0 75 0.2
  demo Draw circle... xMin+2.5 72 0.2
  demo Draw arc...    xMin+2.5 73 0.85 -170 -10
  demo Draw arc...    xMin+2.5 73 1.15 -170 -10
  demo Draw arc...    xMin+1.52 72.1 0.15   10 -170
  demo Draw arc...    xMin+3.48 72.1 0.15  -10 -190

  demo Line width... 1
  demo Marks bottom... 6 yes yes yes
  demo Marks left... 5 yes yes yes
  demo Text top... yes KlankKleuren
  demo Blue
  demo Text special... xMin+0.5 centre yMax bottom Helvetica 24  0 Low
  demo Red
  demo Text special... xMax-0.5 centre yMax bottom Helvetica 24  0 High
  demo Text special... xMax     centre 77.5 top    Helvetica 24 90 Loud
  demo Green
  demo Text special... xMax     centre 62.5 top    Helvetica 24 90 Soft
  demo Text left... yes Loudness (dB)
  demo Text bottom... yes Pitch (ERB)

  demo Black

  endproc

procedure synSound .freq .amp
  Create PitchTier... Source 0 0.5
  Add point... 0.0 1.02*.freq
  Add point... 0.1 0.98*.freq
  Add point... 0.2 1.02*.freq
  Add point... 0.3 0.98*.freq
  Add point... 0.4 1.02*.freq
  Add point... 0.5 0.98*.freq
  To PointProcess
  To Sound (hum)
  Scale intensity... .amp+5
  Play
  plus PitchTier Source
  plus PointProcess Source
  Remove
  endproc

procedure synSoundKey
  rndChoice = (rndChoice mod 10) + 1
  if rndChoice    == 1
    .pitchERB = xMin+2.0
    .loudness = 75
  elsif rndChoice == 2
    .pitchERB = xMin+3.0
    .loudness = 75
  elsif rndChoice == 3
    .pitchERB = xMin+2.5
    .loudness = 72
  elsif rndChoice == 4
    .pitchERB = xMin+1.52
    .loudness = 72.1
  elsif rndChoice == 5
    .pitchERB = xMin+1.7
    .loudness = 70
  elsif rndChoice == 6
    .pitchERB = xMin+2
    .loudness = 68.6
  elsif rndChoice == 7
    .pitchERB = xMin+2.5
    .loudness = 67.9
  elsif rndChoice == 8
    .pitchERB = xMin+3
    .loudness = 68.6
  elsif rndChoice == 9
    .pitchERB = xMin+3.3
    .loudness = 70
  elsif rndChoice == 10
    .pitchERB = xMin+3.48
    .loudness = 72.1
    endif

  demo Paint circle... {0.6,0.6,0.6} .pitchERB .loudness 0.2
  undoCount += 1
  undoDepth'undoCount' = 1
  eraseableObject = 1

  .pitchHz  = erbToHertz(.pitchERB)
  call synSound .pitchHz .loudness
  endproc

procedure anaSound .nrSamples

  if 0.5 < (stopwatch)
    if undoCount <> 0 and usrCounter <> 0 and missedBy > 0 and eraseableObject == 1
      call undoDemo
      endif
    usrCounter += 1
    rapidRepetition = 0
    recordDuration  = 0.7
#   Create Sound from formula... sine Mono 0 0.05 22050 1/2 * sin(2*pi*880*x)
#   Play
#   Remove
  else
    rapidRepetition = 1
    recordDuration  = 0.1
    if eraseableObject == 1
      demo Undo
      undoCount -= 1
      eraseableObject = 0
      endif
    endif

  for j from 1 to .nrSamples
    if j <> 1
#	Undo draw progressbar
#     demo Undo
      if eraseableObject == 1
        demo Undo
        undoCount -= 1
        eraseableObject = 0
        endif
      endif

#	draw progressbar
#   demo Paint rectangle... {0.6,0.6,0.6} xMin xMin+5*j/.nrSamples 60 60.5

    if osIsWindows
      Record Sound (fixed time)... Microphone 1 0.5 11025 recordDuration
    else
      Record Sound (fixed time)... Microphone 1 0.5 44100 recordDuration
      tmpId = selected("Sound")
      Resample... 11025 50
      Rename... untitled
      select tmpId
      Remove
      select Sound untitled
      endif
    Subtract mean
    noprogress To Intensity... 200 0 yes
    yInt = Get maximum... 0 0 Parabolic
    if yInt < yMin
      yInt = yMin
      endif
    tMax = Get time of maximum... 0 0 Parabolic
    Remove

    select Sound untitled
    noprogress To Pitch... 0 50 600
    .p = Get value at time... tMax ERB Linear
    Remove
    if .p <> undefined
      xPitch = .p
      endif

    select Sound untitled
    noprogress To Formant (sl)... 0 4 4000 0.025 50
    .usrF2 = Get quantile... 2 tMax-0.1 tMax+0.1 Hertz 0.5
    .usrF1 = Get quantile... 1 tMax-0.1 tMax+0.1 Hertz 0.5
    plus Sound untitled
    Remove
    if .usrF2 <> undefined and .usrF1 <> undefined
      .usrF2  = hertzToBark(.usrF2)
      .usrF1  = hertzToBark(.usrF1)
      endif

    call setRGB .usrF1 .usrF2
    demo Paint circle... {'r','g','b'} xPitch yInt symSize/10

    eraseableObject = 1
    demoShow()

    undoCount += 1
    undoDepth'undoCount' = 1

    endfor

  if not rapidRepetition or .nrSamples <> 1
    Create Sound from formula... sine Mono 0 0.05 22050 1/2 * sin(2*pi*660*x)
    Play
    Remove
    endif

  stopwatch

  endproc

procedure setRGB .f1 .f2
  .a  = 1.0
  .s  = 1.2
  .x  = (6 -   .f2   ) / 10
  .y  = (2 -   .f1   ) /  8
  .xA = (6 - synF2_a ) / 10
  .yA = (2 - synF1_a ) /  8
  .xU = (6 - synF2_u ) / 10
  .yU = (2 - synF1_u ) /  8
  .xI = (6 - synF2_i ) / 10
  .yI = (2 - synF1_i ) /  8
  .xE = (6 - synF2_e ) / 10
  .yE = (2 - synF1_e ) /  8
  .dA = sqrt((.x-.xA)**2 + ((.y-.yA)/.a)**2) * .s
  .dU = sqrt((.x-.xU)**2 + ( .y-.yU)    **2) * .s
  .dI = sqrt((.x-.xI)**2 + ( .y-.yI)    **2) * .s
  .dE = sqrt((.x-.xE)**2 +  (.y-.yE)    **2) * .s
  .r1 =  1 - min(1, .dU)
  .r2 =  1 - min(1, .dA)
  .g1 =  1 - min(1, .dA)
  .g2 = (1 - min(1, .dE))

  r = max(.r1, .r2)
  g = max(.g1, .g2)
  b = 1 - min(1, .dI)
  endproc

procedure debugCalc
  xPitch = demoX()
  yInt   = demoY()
  demo Draw circle... xPitch yInt symSize/10
  call calcDistance
  endproc

procedure calcDistance
  if yInt > 60
    usrEval += 1
    .dLEye = sqrt((75 - yInt)**2 + (5*(xMin+2.0 - xPitch))**2) - 5 * (symSize/10 + 0.2)
    .dREye = sqrt((75 - yInt)**2 + (5*(xMin+3.0 - xPitch))**2) - 5 * (symSize/10 + 0.2)
    .dNose = sqrt((72 - yInt)**2 + (5*(xMin+2.5 - xPitch))**2) - 5 * (symSize/10 + 0.2)
    if yInt < 72
      .dLips = abs(sqrt((73 - yInt)**2 + (5*(xMin+2.5 - xPitch))**2) - 5*1) - 5 * (symSize/10 + 0.15)
      .dLcom = 10
      .dRcom = 10
    else
      .dLips = 10
      .dLcom = sqrt((72.15 - yInt)**2 + (5*(xMin+1.5 - xPitch))**2) - 5 * (symSize/10 + 0.15)
      .dRcom = sqrt((72.15 - yInt)**2 + (5*(xMin+3.5 - xPitch))**2) - 5 * (symSize/10 + 0.15)
      endif
   .dLips  = min(.dLips, .dLcom, .dRcom)

   if debug
      echo yInt='yInt:2', xPitch='xPitch:2'
      printline .dLEye='.dLEye:2'
      printline .dREye='.dREye:2'
      printline .dNose='.dNose:2'
      printline .dLips='.dLips:2'
      printline .dLcom='.dLcom:2'
      printline .dRcom='.dRcom:2'
      endif

    missedBy = min(.dLEye, .dREye, .dNose, .dLips)
    distance'usrEval' = missedBy
    if missedBy < 0
      demo Undo
      usrHit += 1
      if missedBy   == .dLEye
        smb'usrEval'$ = "left eye   "
        demo Paint circle... {'r','g','b'} xMin+2.0 75 0.2
      elsif missedBy == .dREye
        smb'usrEval'$ = "right eye  "
        demo Paint circle... {'r','g','b'} xMin+3.0 75 0.2
      elsif missedBy == .dNose
        smb'usrEval'$ = "nose       "
        demo Paint circle... {'r','g','b'} xMin+2.5 72 0.2
      elsif missedBy == .dLips
        smb'usrEval'$ = "mouth      "
        demo Colour...       {'r','g','b'}
        demo Line width... 50
        demo Draw arc... xMin+2.5 73 1 -170 -10
        demo Line width... lineWidth
        undoDepth'undoCount' = 4
        endif
# keep the drawing, ...
      eraseableObject = 0
# ... but celebrate only once
      missedBy = 10
      if sndMessage
        Read from file... smSuccess.KK.wav
        endif
    else
      smb'usrEval'$ = "missed     "
      if sndMessage
        Read from file... smFail.KK.wav
        endif
      endif
    if sndMessage
      Play
      Remove
      endif
    yInt = 0
    endif
  endproc

procedure undoDemo
  if undoCount > 0
    for j from 1 to undoDepth'undoCount'
      demo Undo
      endfor
    undoCount -= 1
  else
    call default
    endif
  endproc

procedure setRange
# Create Sound from formula... sine Mono 0 0.05 22050 1/2 * sin(2*pi*880*x)
# Play
# Remove
  Record Sound (fixed time)... Microphone 1 0.5 11025 3
  Subtract mean
  if debug
    Edit
    pause Check
    endif
  To Pitch... 0 75 600
  base = Get quantile... 0 0 0.5 ERB
  plus Sound untitled
  Remove
  Create Sound from formula... sine Mono 0 0.05 22050 1/2 * sin(2*pi*660*x)
  Play
  Remove

  xMin = floor(base)
  xMax = xMin + 5
  xPitch = (xMin + xMax) / 2
  endproc

procedure showScore
  if usrCounter <> 0
    .dTotal  = 0
    .nTrials = 0
    echo =================================================================
    printline Number of trials: 'usrCounter', of which evaluated: 'usrEval', whose tangent: 'usrHit'.
    printline =================================================================
    printline Eval	Target       	Distance

    for j from 1 to usrEval
      .d = distance'j' + 2.0
      .sb$ = smb'j'$
      .nTrials += 1
      .dTotal  += .d
      printline 'j'	'.sb$'	'.d:2'
      endfor

    if .nTrials > 0
      .dMean = .dTotal / .nTrials
      if .dMean > 2.00
        score$ = "Bachelor"
      elsif 1.50 < .dMean && .dMean < 2.00
        score$ = "Master"
      elsif 1.00 < .dMean && .dMean < 1.50
        score$ = "PHD"
      elsif 0.75 < .dMean && .dMean < 1.00
        score$ = "Assistant Professor"
      elsif 0.50 < .dMean && .dMean < 0.75
        score$ = "Full Professor"
      elsif 0.25 < .dMean && .dMean < 0.5
        score$ = "Nobel prize nomination"
      else .dMean
        score$ = "Nobel prize winner"
      endif
      printline =================================================================
      printline Average distance: '.dMean:2' ('.nTrials'/'usrCounter'). Level: 'score$'
      endif
    printline =================================================================

    printline 'newline$'(Close this window to continue.)
    printline (You may press key 'C' to clear the screen.)
#
#	this is apparantly not yet implemented...
#
    demo Copy to clipboard
    endif
  endproc

procedure switchSndMessage
  if sndMessage == 0 and fileReadable("smFail.KK.wav") and fileReadable("smSuccess.KK.wav")
    sndMessage = 1
  else
    sndMessage = 0
    endif
  endproc

procedure KlinkerMikken .stack
  execute KlinkerMikken.praat '.stack'
  call bootKlankKleuren
  call initKlankKleuren
  call initGraph
  endproc

procedure default
  Create Sound from formula... sine Mono 0 0.05 22050 1/2 * sin(2*pi*440*x)
  Play
  Remove
  endproc

label EXIT
select all
#Remove

demo Erase all
demo 24
demo Axes... -14 -6 -8 -2
demo White
demo Paint rectangle... Grey  -17 -3 -11 1
demo Paint rectangle... {0.125,0.698,0.667} -14 -6 -8 -2
demo Viewport text... Centre Half 0 Thanks for your interest!'newline$'
... 'newline$'Phonetics Laboratory'newline$'Universiteit Leiden
demo 14
demo Viewport text... Centre Half 0 'newline$''newline$''newline$''newline$''newline$''newline$''newline$''newline$''newline$'
... 'newline$'on the occasion of the 435^^st^ Anniversary of the Universiteit Leiden
demo 14
demo Viewport text... Centre Bottom 0 (please close this window manually...)
