#	KlinkerMikken (LUCL-submission 'Concours Wetenschap & Wereld') 
#
#	J J A Pacilly,  7-feb-2010, initial demo for Willemijn Heeren
#	J J A Pacilly, 10-jun-2010, included many suggestions by Vincent van Heuven
#	J J A Pacilly,  6-mar-2013, translated visible text to English for Meghan Clayards  
#
#	Distributed under the GNU General Public License

form KlinkerMikken
  integer stackPointer 0
  endform

if stackPointer == undefined
  stackPointer = 0
  endif

call bootKlinkerMikken
call initKlinkerMikken
if stackPointer == 0
  call showHelp
else
  call initGraph
  endif

while demoWaitForInput()
  if demoClickedIn(xMin, xMax, yMin, yMax)
    if demoShiftKeyPressed()
      call setProjection -demoY() -demoX()
    else
      call getFromGraph
      endif
  elsif demoClickedIn(xMin-2, xMin, yMin, yMax)
    call getFromSet 4
  elsif demoClickedIn(xMax, xMax+2, yMin, yMax)
    call getFromSet 1
  elsif demoKeyPressed()
    key$ = demoKey$()
    if key$ = "?" or key$ = "h" or key$ = "H"
      call showHelp
    elsif key$ = "e" or  key$ = "E"
      call getFromSet 4
    elsif key$ = "n" or  key$ = "N"
      call getFromSet 1
    elsif key$ = "r" or key$ = "R"
      call replay
    elsif key$ = " "
      call anaVowel
    elsif key$ = "o" or  key$ = "O"
      call undoDemo
    elsif key$ = "s" or key$ = "S"
      call showScore
    elsif key$ = "k" or key$ = "K"
      call anaVowel
    elsif key$ = "b" or key$ = "B"
      call switchScale
    elsif key$ = "c" or key$ = "C"
      if demoShiftKeyPressed()
        call initKlinkerMikken
        endif
      call initGraph
    elsif key$ = "g" or key$ = "G"
      call switchSndMessage
    elsif key$ = "1"
      symSize   = 1
      lineWidth = 1
    elsif key$ = "2"
      symSize   = 2
      lineWidth = 2
    elsif key$ = "3"
      symSize   = 3
      lineWidth = 3
    elsif key$ = "4"
      symSize   = 4
      lineWidth = 5
    elsif  key$ = ""
      call KlankKleuren stackPointer+1
    elsif key$ = ""
      goto EXIT
    else
      call default
      endif
    endif
  endwhile


procedure bootKlinkerMikken
  if stackPointer == 0
    demoWindowTitle("KlinkerMikken - Phonetics Laboratory Leiden")
  else
    demoWindowTitle("KlinkerMikken - Phonetics Laboratory Leiden ['stackPointer']")
    endif
  select all
  nocheck Remove
  xMin       = -16
  xMax       =  -6
  yMin       = -10
  yMax       =  -2
  synF2_a    =  10
  synF1_a    =   8
  synF2_u    =   6
  synF1_u    =   3
  synF2_i    =  14
  synF1_i    =   2.7
  synF2_e    = (synF2_a + synF2_i)/2 + 1
  synF1_e    = (synF1_a + synF1_i)/2 + 1
  sndMessage =   0
  call switchSndMessage
  osIsWindows = index(environment$("os"), "Windows")

# Algemene Fonetiek, Rietveld & van Heuven, blz. 342, Adank et al. (2004)

  Create Table with column names... Adank2004 12 IPA F1 F2 F3
  id1 = selected("Table")
  Set string value...  1 IPA i
  Set numeric value... 1  F1  278
  Set numeric value... 1  F2 2162
  Set numeric value... 1  F3 2911
  Set string value...  2 IPA y
  Set numeric value... 2  F1  259
  Set numeric value... 2  F2 1734
  Set numeric value... 2  F3 2635
  Set string value...  3 IPA u
  Set numeric value... 3  F1  259
  Set numeric value... 3  F2  805
  Set numeric value... 3  F3 2736
  Set string value...  4 IPA e
  Set numeric value... 4  F1  400
  Set numeric value... 4  F2 1995
  Set numeric value... 4  F3 2908
  Set string value...  5 IPA \o/
  Set numeric value... 5  F1  375
  Set numeric value... 5  F2 1563
  Set numeric value... 5  F3 2550
  Set string value...  6 IPA o
  Set numeric value... 6  F1  412
  Set numeric value... 6  F2  929
  Set numeric value... 6  F3 2417
  Set string value...  7 IPA a
  Set numeric value... 7  F1  670
  Set numeric value... 7  F2 1425
  Set numeric value... 7  F3 2852
  Set string value...  8 IPA \ic
  Set numeric value... 8  F1  361
  Set numeric value... 8  F2 1919
  Set numeric value... 8  F3 2883
  Set string value...  9 IPA \o-
  Set numeric value... 9  F1  366
  Set numeric value... 9  F2 1595
  Set numeric value... 9  F3 2711
  Set string value...  10 IPA  \ep
  Set numeric value... 10 F1  475
  Set numeric value... 10 F2 1739
  Set numeric value... 10 F3 2871
  Set string value...  11 IPA  \ct
  Set numeric value... 11 F1  402
  Set numeric value... 11 F2 821
  Set numeric value... 11 F3 3013
  Set string value...  12 IPA  \as
  Set numeric value... 12 F1  578
  Set numeric value... 12 F2 1172
  Set numeric value... 12 F3 2895

# Algemene Fonetiek, Rietveld & van Heuven, blz. 342, Pols (1977)

  Create Table with column names... Pols1977 12 IPA F1 F2 F3
  id2 = selected("Table")
  Set string value...  1 IPA i
  Set numeric value... 1  F1  294
  Set numeric value... 1  F2 2208
  Set numeric value... 1  F3 2766
  Set string value...  2 IPA y
  Set numeric value... 2  F1  305
  Set numeric value... 2  F2 1730
  Set numeric value... 2  F3 2208
  Set string value...  3 IPA u
  Set numeric value... 3  F1  339
  Set numeric value... 3  F2  810
  Set numeric value... 3  F3 2323
  Set string value...  4 IPA e
  Set numeric value... 4  F1  407
  Set numeric value... 4  F2 2017
  Set numeric value... 4  F3 2553
  Set string value...  5 IPA \o/
  Set numeric value... 5  F1  443
  Set numeric value... 5  F2 1497
  Set numeric value... 5  F3 2260
  Set string value...  6 IPA o
  Set numeric value... 6  F1  487
  Set numeric value... 6  F2  911
  Set numeric value... 6  F3 2481
  Set string value...  7 IPA a
  Set numeric value... 7  F1  795
  Set numeric value... 7  F2 1301
  Set numeric value... 7  F3 2565
  Set string value...  8 IPA \ic
  Set numeric value... 8  F1  388
  Set numeric value... 8  F2 2003
  Set numeric value... 8  F3 2571
  Set string value...  9 IPA \o-
  Set numeric value... 9  F1  438
  Set numeric value... 9  F2 1498
  Set numeric value... 9  F3 2354
  Set string value...  10 IPA  \ep
  Set numeric value... 10 F1  583
  Set numeric value... 10 F2 1725
  Set numeric value... 10 F3 2471
  Set string value...  11 IPA  \ct
  Set numeric value... 11 F1  523
  Set numeric value... 11 F2 866
  Set numeric value... 11 F3 2692
  Set string value...  12 IPA  \as
  Set numeric value... 12 F1  679
  Set numeric value... 12 F2 1051
  Set numeric value... 12 F3 2619

  Create formant table (Pols & Van Nierop 1973)
  Extract rows where column (text)... Sex "is equal to" m
  id3 = selected("Table")
  select Table pvn
  Remove

  Create formant table (Peterson & Barney 1952)
# Extract rows where column (text)... Sex "is equal to" m
  Extract rows where column (text)... Speaker "is equal to" 8
 
  id4 = selected("Table")
  select Table pb
  Remove

  Create formant table (Weenink 1985)
  Extract rows where column (text)... Type "is equal to" m
  id5 = selected("Table")
  select Table m10w10c10
  Remove

  endproc

procedure initKlinkerMikken
  nocheck select Sound Vowel
  if numberOfSelected("Sound") <> 0
    Remove
    endif
  synCounter  = 0
  synCounter1 = 0
  synCounter2 = 0
  synCounter3 = 0
  synCounter4 = 0
  synCounter5 = 0
  usrCounter1 = 0
  units$      = "Bark'"
  symSize     = 2
  lineWidth   = 2
  usrF2_a     = synF2_a
  usrF1_a     = synF1_a
  usrF2_u     = synF2_u
  usrF1_u     = synF1_u
  usrF2_i     = synF2_i
  usrF1_i     = synF1_i

  setProjection.a2  = 0
  setProjection.b2  = 0
  setProjection.c2  = 0
  setProjection.a1  = 0
  setProjection.b1  = 0
  setProjection.c1  = 0
  select id1
  plus id2
  plus id3
  plus id4
  plus id5
  Randomize rows
  endproc

procedure resetKlinkerMikken
  if synCounter <> 0
    select Sound Vowel
    Remove
    endif
  synCounter  = 0
  usrCounter1 = 0
  undoCount   = 0
  endproc

procedure showHelp
  call resetKlinkerMikken
  demo Erase all
  demo 24
  demo Axes... -14 -6 -8 -2

  demo White
  demo Paint rectangle... Grey  -17 -3 -11 1
  demo Paint rectangle... {0.125,0.698,0.667} -14 -6 -8 -2
  demo Text special... -13.5 left -2.5 top Helvetica 18 0 ##Control Keys %%KlinkerMikken%#'newline$'
... 'newline$'#H or #?
... 'newline$'mouse click
... 'newline$'#R
... 'newline$'<space>
... 'newline$'#S
... 'newline$'#K (or shift/click)
... 'newline$'#B (choose 1/2)
... 'newline$'
... 'newline$'#1, #2, #3 of #4
... 'newline$'#C
... 'newline$'shift/#C
... 'newline$'ctrl/#C
... 'newline$'ctrl/#X
  demo Text special... -11.5 left -2.5 top Helvetica 18 0 'newline$'
... 'newline$'show this help text
... 'newline$'synthesize a new target vowel
... 'newline$'replay the synthesized vowel
... 'newline$'plot your vowel (speak before the beep)
... 'newline$'show your score
... 'newline$'define your vowel space
... 'newline$'1: plot 'projected' vowels  (%%Bark#'%)
... 'newline$'2: plot vowels using absolute scales (%%Bark%)
... 'newline$'select symbol size
... 'newline$'clear screen
... 'newline$'restart %%KlinkerMikken%
... 'newline$'close the programm
... 'newline$'continue with %%KlankKleuren%
  demo 14
  demo Viewport text... Centre Bottom 0 (press #C or shift/#C to restart %%KlinkerMikken%
  endproc

procedure initGraph
  call resetKlinkerMikken

  if units$ == "Bark"
    .usrColor$ = "Black"
    .usrF2_a = usrF2_a
    .usrF1_a = usrF1_a
    .usrF2_u = usrF2_u
    .usrF1_u = usrF1_u
    .usrF2_i = usrF2_i
    .usrF1_i = usrF1_i
  else
    .usrColor$ = "{0.75,0.75,0.75}"
    .usrF2_a = synF2_a
    .usrF1_a = synF1_a
    .usrF2_u = synF2_u
    .usrF1_u = synF1_u
    .usrF2_i = synF2_i
    .usrF1_i = synF1_i
    endif

  demo Erase all
  demo 24
  demo Axes... xMin xMax yMin yMax

  demo Paint rectangle... {0.6,0.6,0.6} xMin xMax yMin yMax
  demo Line width... 1
  demo Draw inner box

  Create simple Matrix... Formants 3 2  0
  Set value... 1 1 -synF2_a
  Set value... 1 2 -synF1_a
  Set value... 2 1 -synF2_u
  Set value... 2 2 -synF1_u
  Set value... 3 1 -synF2_i
  Set value... 3 2 -synF1_i

  To Polygon
  demo Paint... 0.75 xMin xMax yMin yMax
  plus Matrix Formants
  Remove

  demo White
  demo Text special... -synF2_a centre -synF1_a top    Helvetica 24 0 [a]
  demo Text special... -synF2_u right  -synF1_u bottom Helvetica 24 0 [u]
  demo Text special... -synF2_i right  -synF1_i bottom Helvetica 24 0 [i]

  Create simple Matrix... Formants 4 2  0
  Set value... 1 1 -.usrF2_a
  Set value... 1 2 -.usrF1_a
  Set value... 2 1 -.usrF2_u
  Set value... 2 2 -.usrF1_u
  Set value... 3 1 -.usrF2_i
  Set value... 3 2 -.usrF1_i
  Set value... 4 1 -.usrF2_a
  Set value... 4 2 -.usrF1_a

  To Polygon
  demo Black
  demo Line width... lineWidth
  demo Draw... xMin xMax yMin yMax
  plus Matrix Formants
  Remove

  demo White
  demo Draw arrow... -usrF2_a -usrF1_a -synF2_a -synF1_a
  demo Draw arrow... -usrF2_u -usrF1_u -synF2_u -synF1_u
  demo Draw arrow... -usrF2_i -usrF1_i -synF2_i -synF1_i

  demo Colour... '.usrColor$'
  demo Text special... -.usrF2_a centre -.usrF1_a top    Helvetica 24 0 [a]
  demo Text special... -.usrF2_u right  -.usrF1_u bottom Helvetica 24 0 [u]
  demo Text special... -.usrF2_i right  -.usrF1_i bottom Helvetica 24 0 [i]

  demo Blue
  demo Line width... 1
  demo Marks bottom... 6 yes yes yes
  demo Marks left... 5 yes yes yes
  demo Text top... yes KlinkerMikken

  demo Colour... {0.9,0.9,0}
  y = (5*yMin + yMax) / 6
  demo Text special...  xMax centre y   top  Helvetica 24 90 Open

  demo Red
  x7_8 = (xMin + 7*xMax) / 8
  demo Text special...  x7_8 centre yMax bottom Helvetica 24  0 Back
  y5_6 = (yMin + 5*yMax) / 6
  demo Text special...  xMax centre y5_6   top  Helvetica 24 90 Closed

  demo Blue
  x1_8 = (7*xMin + xMax) / 8
  demo Text special... x1_8 centre yMax bottom Helvetica 24  0 Front

  demo Text left... yes first Formant ('units$')
  demo Text bottom... yes second Formant ('units$')

  endproc

procedure setProjection .f1 .f2
  if .f1 > 5
    usrF2_a = .f2
    usrF1_a = .f1
  elsif .f2 < 10
    usrF2_u = .f2
    usrF1_u = .f1
  else
    usrF2_i = .f2
    usrF1_i = .f1
    endif
  call initGraph

#	Calculate the coefficients a, b and c for a two dimensinal linear inter/extrapolation.
#
#	The planes p2(f2,f1) = a2 + b2*x + c2*y and p1(f2,f1) = a1 + b1*x + c1*y represent the
#	difference in formant values F2 and F1 used for the Vowel synthesis as opposed to the
#	'Vowel space', in which the *measured* user formants are plotted (marked by white arrows).

  .dxA  = synF2_a - usrF2_a
  .dyA  = synF1_a - usrF1_a
  .dxU  = synF2_u - usrF2_u
  .dyU  = synF1_u - usrF1_u
  .dxI  = synF2_i - usrF2_i
  .dyI  = synF1_i - usrF1_i

  .xA = usrF2_a
  .yA = usrF1_a
  .xU = usrF2_u
  .yU = usrF1_u
  .xI = usrF2_i
  .yI = usrF1_i

  .c2 = ((.dxI - .dxA) * (.xU - .xA) - (.dxU - .dxA) * (.xI - .xA)) / 
...     ((.yI  - .yA ) * (.xU - .xA) - (.yU  - .yA)  * (.xI - .xA))
# .b2 = ((.dxI - .dxA) * (.yU - .yA) - (.dxU - .dxA) * (.yI - .yA)) / 
#...    ((.xI  - .xA ) * (.yU - .yA) - (.xU  - .xA ) * (.yI - .yA))
  .b2 = (.dxU  - .dxA - .c2 * (.yU - .yA)) / (.xU - .xA)
# .b2 = (.dxI  - .dxA - .c2 * (.yI - .yA)) / (.xI - .xA)
  .a2 =  .dxA  - .b2 * .xA - .c2 * .yA

  .c1 = ((.dyI - .dyA) * (.xU - .xA) - (.dyU - .dyA) * (.xI - .xA)) / 
...     ((.yI  - .yA ) * (.xU - .xA) - (.yU  - .yA)  * (.xI - .xA))
  .b1 = (.dyU  - .dyA - .c1 * (.xU - .xA)) / (.yU - .yA)
  .a1 =  .dyA  - .b1 * .xA - .c1 * .yA

  endproc

procedure getFromGraph
  synCounter += 1
  synF1 = -demoY()
  synF2 = -demoX()
  synF3 = 2/3 * synF2 + 1/3 * 20
  synF4 = 1/3 * synF2 + 2/3 * 20
  symbol$ = "'synCounter'"
  call synVowel 120 80 synF1 synF2 synF3 synF4
  endproc

procedure getFromSet .table
  synCounter += 1
  select id'.table'
  nrRows = Get number of rows
  if synCounter'.table' < nrRows
    synCounter'.table' += 1
  else
    synCounter'.table' = 1
    endif
  if .table <= 2
    .f0 = 100
  else
    .f0 = Get value... synCounter'.table' F0
    endif
  .f1Hz = Get value... synCounter'.table' F1
  .f2Hz = Get value... synCounter'.table' F2
  .f3Hz = Get value... synCounter'.table' F3
  synF1 = hertzToBark(.f1Hz)
  synF2 = hertzToBark(.f2Hz)
  synF3 = hertzToBark(.f3Hz)
  synF4 = 1/2 * synF3 + 1/2 * 20
  symbol$ = Get value... synCounter'.table' IPA
  call synVowel .f0*1.2 .f0*0.8 synF1 synF2 synF3 synF4
  endproc

procedure synVowel .f0b .f0e .f1 .f2 .f3 .f4
  if synCounter > 1
    select Sound Vowel
    Remove
    endif
  undoCount               = 0
  usrCounter'synCounter'  = 0
  bestAttempt'synCounter' = 0
  bestValueF1'synCounter' = 0
  bestValueF2'synCounter' = 0
  distance'synCounter'    = 99

  call setRGB .f1 .f2
# demo Paint circle... {'r','g','b'} -synF2 -synF1 symSize/5
  demo Paint circle... {'r','g','b'} -.f2 -.f1 symSize/5
  demo White
# demo Text special... demoX() centre demoY() half Helvetica 18*symSize 0 'synCounter'
  demo Text special... -.f2 centre -.f1 half Helvetica 18*symSize 0 'symbol$'
  .f1b = barkToHertz(.f1)
  .f2b = barkToHertz(.f2)
  .f3b = barkToHertz(.f3)
  .f4b = barkToHertz(.f4)
  .f1e = barkToHertz(.f1)
  .f2e = barkToHertz(.f2)
  .f3e = barkToHertz(.f3)
  .f4e = barkToHertz(.f4)

  Create PitchTier... Source 0 0.4
  Add point... 0 .f0b
  Add point... 0.4 .f0e
  To PointProcess
  To Sound (pulse train)... 11025 1 0.05 2000
  Filter (de-emphasis)... 50
  select PitchTier Source
  plus PointProcess Source
  plus Sound Source_deemp
  Remove

  Create FormantTier... Filter 0 0.4
  .b1 = .f1b / 10
  .b2 = .f2b / 10
  .b3 = .f3b / 10
  .b4 = .f4b / 10
  Add point... 0.0 '.f1b' '.b1' '.f2b' '.b2' '.f3b' '.b3' '.f4b' '.b4'
  .b1 = .f1e / 10
  .b2 = .f2e / 10
  .b3 = .f3e / 10
  .b4 = .f4e / 10
  Add point... 0.4 '.f1e' '.b1' '.f2e' '.b2' '.f3e' '.b3' '.f4e' '.b4'

  select Sound Source
  plus FormantTier Filter
  Filter
  Rename... Vowel
  Formula... if x < 0.010 then self * x/0.010 else self fi

  select Sound Source
  plus FormantTier Filter
  Remove

  select Sound Vowel
  Play
  endproc

procedure setRGB .f1 .f2
  .a  = 1.0
  .s  = 1.2
  .x  = (  .f2   + xMax) / (xMax - xMin)
  .y  = (  .f1   + yMax) / (yMax - yMin)
  .xA = (synF2_a + xMax) / (xMax - xMin)
  .yA = (synF1_a + yMax) / (yMax - yMin)
  .xU = (synF2_u + xMax) / (xMax - xMin)
  .yU = (synF1_u + yMax) / (yMax - yMin)
  .xI = (synF2_i + xMax) / (xMax - xMin)
  .yI = (synF1_i + yMax) / (yMax - yMin)
  .xE = (synF2_e + xMax) / (xMax - xMin)
  .yE = (synF1_e + yMax) / (yMax - yMin)
  .dA = sqrt((.x-.xA)**2 + ((.y-.yA)/.a)**2) * .s
  .dU = sqrt((.x-.xU)**2 + ( .y-.yU)    **2) * .s
  .dI = sqrt((.x-.xI)**2 + ( .y-.yI)    **2) * .s
  .dE = sqrt((.x-.xE)**2 +  (.y-.yE)    **2) * .s
  .r1 =  1 - min(1, .dU)
  .r2 =  1 - min(1, .dA)
  .g1 =  1 - min(1, .dA)
  .g2 = (1 - min(1, .dE))

  r = max(.r1, .r2)
  g = max(.g1, .g2)
  b = 1 - min(1, .dI)
  endproc

procedure replay
  if synCounter <> 0
    select Sound Vowel
    Play
    endif
  endproc

procedure anaVowel
# Create Sound from formula... sine Mono 0 0.05 22050 1/2 * sin(2*pi*880*x)
# Play
# Remove
  if osIsWindows
    Record Sound (fixed time)... Microphone 1 0.5 11025 0.7
  else
    Record Sound (fixed time)... Microphone 1 0.5 44100 0.7
    tmpId = selected("Sound")
    Resample... 11025 50
    Rename... untitled
    select tmpId
    Remove
    endif
  Create Sound from formula... sine Mono 0 0.05 22050 1/2 * sin(2*pi*660*x)
  Play
  Remove
  select Sound untitled
  Subtract mean
  To Intensity... 100 0 yes
  tMax = Get time of maximum... 0 0 Parabolic
  select Sound untitled
  To Formant (sl)... 0 4 4000 0.025 50
  .usrF2 = Get quantile... 2 tMax-0.1 tMax+0.1 Hertz 0.5
  .usrF1 = Get quantile... 1 tMax-0.1 tMax+0.1 Hertz 0.5
#
#   demo Scatter plot... 0 0 2 2357 628 1 915 188 1 yes + (klopt niet meer)
#   demo Axes... xMin xMax yMin yMax
#
  if .usrF2 <> undefined and .usrF1 <> undefined
    .usrF2  = hertzToBark(.usrF2)
    .usrF1  = hertzToBark(.usrF1)

    if (key$ = "k" or key$ = "K")
      call setProjection anaVowel.usrF1 anaVowel.usrF2
    else
      .usrF2_org = .usrF2
      .usrF1_org = .usrF1

      .usrF2 += setProjection.a2 + setProjection.b2 * .usrF2_org + setProjection.c2 * .usrF1_org
      .usrF1 += setProjection.a1 + setProjection.b1 * .usrF2_org + setProjection.c1 * .usrF1_org

      if synCounter == 0
        undoCount += 1
      else
        demo Line width... lineWidth
        demo Black
        demo Draw arrow... -.usrF2 -.usrF1 -synF2 -synF1
        endif

      call setRGB .usrF1 .usrF2
      demo Paint circle...    {'r','g','b'} -.usrF2 -.usrF1 symSize/10
#     demo Paint rectangle... {'r','g','b'} -.usrF2-symSize/10 -.usrF2+symSize/10 -.usrF1-symSize/12.5 -.usrF1+symSize/12.5

      if units$ == "Bark"
        demo Line width... lineWidth
        demo White
        demo Draw arrow...  -.usrF2_org -.usrF1_org -.usrF2 -.usrF1 
        demo Black
        demo Draw circle... -.usrF2_org -.usrF1_org symSize/10
        endif

      if synCounter <> 0
        usrCounter'synCounter' += 1
        .u  = usrCounter'synCounter'
        demo Black
        demo Text special... -.usrF2 centre -.usrF1 half Helvetica 10*symSize 0 '.u'
        .d = sqrt((synF1 - .usrF1)**2 + (synF2 - .usrF2)**2)
        if .d < distance'synCounter'
          bestAttempt'synCounter' = usrCounter'synCounter'
          smb'synCounter'$        = symbol$
          synf1'synCounter'       = synF1
          synf2'synCounter'       = synF2
          usrf1'synCounter'       = .usrF1
          usrf2'synCounter'       = .usrF2
          distance'synCounter'    = .d
          endif
        if sndMessage and .d < symSize/10
          Read from file... smSuccess.KM.wav
          Play
          Remove
          endif
        endif
      endif
    endif
  select Sound untitled
  plus Intensity untitled
  plus Formant untitled
  Remove
  endproc

procedure undoDemo
  if undoCount > 0
    demo Undo
    if units$ == "Bark"
      for j from 1 to 5
        demo Undo
        endfor
      endif
    undoCount -= 1
  else
    call default
    endif
  endproc

procedure showScore
  if synCounter <> 0
    .dTotal  = 0
    .nTrials = 0
    echo =================================================================
    printline Number of vowels: 'synCounter'
    printline =================================================================
    printline Vowel		target		realised	deviation
    for j from 1 to synCounter
      .d = distance'j'
      if .d < 99
        .sb$ = smb'j'$
        .b   = bestAttempt'j'
        .n   = usrCounter'j'
        .sF1 = synf1'j'
        .sF2 = synf2'j'
        .uF1 = usrf1'j'
        .uF2 = usrf2'j'
        .nTrials += 1
        .dTotal  += .d
        printline '.sb$'	('.b'/'.n') 	'.sF2:1', '.sF1:1' 	'.uF2:1', '.uF1:1' 	'.d:2' Bark
        endif
      endfor

    if .nTrials > 0
      .dMean = .dTotal / .nTrials
      if .dMean > 2.00
        score$ = "Bachelor"
      elsif 1.50 < .dMean && .dMean < 2.00
        score$ = "Master"
      elsif 1.00 < .dMean && .dMean < 1.50
        score$ = "PHD"
      elsif 0.75 < .dMean && .dMean < 1.00
        score$ = "Assistant Professor"
      elsif 0.50 < .dMean && .dMean < 0.75
        score$ = "Full Professor"
      elsif 0.25 < .dMean && .dMean < 0.5
        score$ = "Nobel prize nomination"
      else .dMean
        score$ = "Nobel prize winner"
      endif
      printline =================================================================
      printline Mean deviation: '.dMean:2' Bark ('.nTrials'/'synCounter'). Level: 'score$'
      endif
    printline =================================================================

    printline 'newline$'(Close this window to continue.)
    printline (You may press key 'C' to clear the screen.)
#
#	this is apparantly not yet implemented...
#
    demo Copy to clipboard
    endif
  endproc

procedure switchScale
  if units$ == "Bark"
    units$ = "Bark'"
  else
    units$ = "Bark"
    endif
  call initGraph
  endproc

procedure switchSndMessage
  if sndMessage == 0 and fileReadable("smSuccess.KM.wav")
    sndMessage = 1
  else
    sndMessage = 0
    endif
  endproc

procedure KlankKleuren .stack
#
# ToDo: keep carefull track of objects, so you can retain them (as well as the variables)...
#
  select all
  Remove
  execute KlankKleuren.praat '.stack'
  call bootKlinkerMikken
  call initKlinkerMikken
  call initGraph
  endproc

procedure default
  Create Sound from formula... sine Mono 0 0.05 22050 1/2 * sin(2*pi*440*x)
  Play
  Remove
  endproc

label EXIT
select all
Remove

demo Erase all
demo 24
demo Axes... -14 -6 -8 -2
demo White
demo Paint rectangle... Grey  -17 -3 -11 1
demo Paint rectangle... {0.125,0.698,0.667} -14 -6 -8 -2
demo Viewport text... Centre Half 0 Thanks for your interest!'newline$'
... 'newline$'Phonetics Laboratory'newline$'Universiteit Leiden
demo 14
demo Viewport text... Centre Half 0 'newline$''newline$''newline$''newline$''newline$''newline$''newline$''newline$''newline$'
... 'newline$'on the occasion of the 435^^st^ Anniversary of the Universiteit Leiden
demo 14
demo Viewport text... Centre Bottom 0 (please close this window manually...)
